*** a/src/include/nodes/primnodes.h
--- b/src/include/nodes/primnodes.h
***************
*** 247,255 **** typedef struct Aggref
--- 247,258 ----
  	List	   *args;			/* arguments and sort expressions */
  	List	   *aggorder;		/* ORDER BY (list of SortGroupClause) */
  	List	   *aggdistinct;	/* DISTINCT (list of SortGroupClause) */
+ 	List	   *orddirectargs;	/* Direct arguments for ordered set functions */
  	Expr	   *aggfilter;		/* FILTER expression */
  	bool		aggstar;		/* TRUE if argument list was really '*' */
  	bool		aggvariadic;	/* TRUE if VARIADIC was used in call */
+ 	bool		isordset;	/* If node is from an ordered set function */
+ 	bool		ishypothetical;	/* If node is from a hypothetical set function */
  	Index		agglevelsup;	/* > 0 if agg belongs to outer query */
  	int			location;		/* token location, or -1 if unknown */
  } Aggref;
*** a/src/include/parser/kwlist.h
--- b/src/include/parser/kwlist.h
***************
*** 412,417 **** PG_KEYWORD("where", WHERE, RESERVED_KEYWORD)
--- 412,418 ----
  PG_KEYWORD("whitespace", WHITESPACE_P, UNRESERVED_KEYWORD)
  PG_KEYWORD("window", WINDOW, RESERVED_KEYWORD)
  PG_KEYWORD("with", WITH, RESERVED_KEYWORD)
+ PG_KEYWORD("within", WITHIN, UNRESERVED_KEYWORD)
  PG_KEYWORD("without", WITHOUT, UNRESERVED_KEYWORD)
  PG_KEYWORD("work", WORK, UNRESERVED_KEYWORD)
  PG_KEYWORD("wrapper", WRAPPER, UNRESERVED_KEYWORD)
*** a/src/include/parser/parse_agg.h
--- b/src/include/parser/parse_agg.h
***************
*** 17,23 ****
  
  extern void transformAggregateCall(ParseState *pstate, Aggref *agg,
  					   List *args, List *aggorder,
! 					   bool agg_distinct);
  extern void transformWindowFuncCall(ParseState *pstate, WindowFunc *wfunc,
  						WindowDef *windef);
  
--- 17,23 ----
  
  extern void transformAggregateCall(ParseState *pstate, Aggref *agg,
  					   List *args, List *aggorder,
! 					   bool agg_distinct, bool agg_within_group);
  extern void transformWindowFuncCall(ParseState *pstate, WindowFunc *wfunc,
  						WindowDef *windef);
  
***************
*** 34,37 **** extern void build_aggregate_fnexprs(Oid *agg_input_types,
--- 34,51 ----
  						Expr **transfnexpr,
  						Expr **finalfnexpr);
  
+ void
+ build_orderedset_fnexprs(Oid *agg_input_types,
+ 					int agg_num_inputs,
+ 					bool agg_variadic,
+ 					Oid agg_result_type,
+ 					Oid agg_input_collation,
+ 					Oid *agg_input_collation_array,
+ 					Oid finalfn_oid,
+ 					Expr **finalfnexpr);
+ 
+ int get_aggregate_argtypes(Aggref *aggref, 
+ 				Oid *inputTypes, 
+ 				Oid *inputCollations);
+ 
  #endif   /* PARSE_AGG_H */
*** a/src/include/parser/parse_clause.h
--- b/src/include/parser/parse_clause.h
***************
*** 31,37 **** extern List *transformGroupClause(ParseState *pstate, List *grouplist,
  					 ParseExprKind exprKind, bool useSQL99);
  extern List *transformSortClause(ParseState *pstate, List *orderlist,
  					List **targetlist, ParseExprKind exprKind,
! 					bool resolveUnknown, bool useSQL99);
  
  extern List *transformWindowDefinitions(ParseState *pstate,
  						   List *windowdefs,
--- 31,37 ----
  					 ParseExprKind exprKind, bool useSQL99);
  extern List *transformSortClause(ParseState *pstate, List *orderlist,
  					List **targetlist, ParseExprKind exprKind,
! 					bool resolveUnknown, bool useSQL99, bool keepDuplicates);
  
  extern List *transformWindowDefinitions(ParseState *pstate,
  						   List *windowdefs,
*** a/src/include/parser/parse_func.h
--- b/src/include/parser/parse_func.h
***************
*** 38,51 **** typedef enum
  	FUNCDETAIL_NORMAL,			/* found a matching regular function */
  	FUNCDETAIL_AGGREGATE,		/* found a matching aggregate function */
  	FUNCDETAIL_WINDOWFUNC,		/* found a matching window function */
! 	FUNCDETAIL_COERCION			/* it's a type coercion request */
  } FuncDetailCode;
  
- 
  extern Node *ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
! 				  List *agg_order, Expr *agg_filter,
! 				  bool agg_star, bool agg_distinct, bool func_variadic,
! 				  WindowDef *over, bool is_column, int location);
  
  extern FuncDetailCode func_get_detail(List *funcname,
  				List *fargs, List *fargnames,
--- 38,48 ----
  	FUNCDETAIL_NORMAL,			/* found a matching regular function */
  	FUNCDETAIL_AGGREGATE,		/* found a matching aggregate function */
  	FUNCDETAIL_WINDOWFUNC,		/* found a matching window function */
! 	FUNCDETAIL_COERCION,			/* it's a type coercion request */
  } FuncDetailCode;
  
  extern Node *ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
! 							   int location, FuncCall *fn);
  
  extern FuncDetailCode func_get_detail(List *funcname,
  				List *fargs, List *fargnames,
***************
*** 66,73 **** extern FuncCandidateList func_select_candidate(int nargs,
  
  extern void make_fn_arguments(ParseState *pstate,
  				  List *fargs,
  				  Oid *actual_arg_types,
! 				  Oid *declared_arg_types);
  
  extern const char *funcname_signature_string(const char *funcname, int nargs,
  						  List *argnames, const Oid *argtypes);
--- 63,72 ----
  
  extern void make_fn_arguments(ParseState *pstate,
  				  List *fargs,
+ 				  List *agg_order,
  				  Oid *actual_arg_types,
! 				  Oid *declared_arg_types,
! 				  bool requiresUnification);
  
  extern const char *funcname_signature_string(const char *funcname, int nargs,
  						  List *argnames, const Oid *argtypes);
*** a/src/include/utils/builtins.h
--- b/src/include/utils/builtins.h
***************
*** 658,663 **** extern Datum pg_get_functiondef(PG_FUNCTION_ARGS);
--- 658,665 ----
  extern Datum pg_get_function_arguments(PG_FUNCTION_ARGS);
  extern Datum pg_get_function_identity_arguments(PG_FUNCTION_ARGS);
  extern Datum pg_get_function_result(PG_FUNCTION_ARGS);
+ extern Datum pg_get_aggregate_arguments(PG_FUNCTION_ARGS);
+ extern Datum pg_get_aggregate_identity_arguments(PG_FUNCTION_ARGS);
  extern char *deparse_expression(Node *expr, List *dpcontext,
  				   bool forceprefix, bool showimplicit);
  extern List *deparse_context_for(const char *aliasname, Oid relid);
*** a/src/test/regress/sql/aggregates.sql
--- b/src/test/regress/sql/aggregates.sql
***************
*** 481,486 **** select aggfns(distinct a,b,c order by a,c using ~<~,b) filter (where a > 1)
--- 481,549 ----
      from (values (1,3,'foo'),(0,null,null),(2,2,'bar'),(3,1,'baz')) v(a,b,c),
      generate_series(1,2) i;
  
+ -- ordered set functions
+ 
+ select p, percentile_cont(p) within group (order by x::float8) from generate_series(1,5) x, 
+ 	(values (0::float8),(0.1),(0.25),(0.4),(0.5),(0.6),(0.75),(0.9),(1)) v(p) 
+ 	group by p order by p;
+ select p, percentile_cont(p order by p) within group (order by x::float8) 
+ 	from generate_series(1,5) x, (values (0::float8),(0.1),(0.25),(0.4),(0.5),(0.6),(0.75),(0.9),(1)) v(p) 
+ 	group by p order by x;
+ select p, sum() within group (order by x::float8) 
+ 	from generate_series(1,5) x, 
+ 	(values (0::float8),(0.1),(0.25),(0.4),(0.5),(0.6),(0.75),(0.9),(1)) v(p) group by p order by p;
+ select p, percentile_cont(p,p) from generate_series(1,5) x, 
+ 	(values (0::float8),(0.1),(0.25),(0.4),(0.5),(0.6),(0.75),(0.9),(1)) v(p) group by p order by p;
+ select percentile_cont(0.5) within group (order by b) from aggtest;
+ select percentile_cont(0.5) within group (order by b),sum(b) from aggtest;
+ select percentile_cont(0.5) within group (order by thousand) from tenk1;
+ select percentile_disc(0.5) within group (order by thousand) from tenk1;
+ select rank(3) within group (order by x) from (values (1),(1),(2),(2),(3),(3),(4)) v(x);
+ select cume_dist(3) within group (order by x) from (values (1),(1),(2),(2),(3),(3),(4)) v(x);
+ select percent_rank(3) within group (order by x) from (values (1),(1),(2),(2),(3),(3),(4),(5)) v(x);
+ select dense_rank(3) within group (order by x) from (values (1),(1),(2),(2),(3),(3),(4)) v(x);
+ 
+ select percentile_disc(array[0,0.1,0.25,0.5,0.75,0.9,1]) within group (order by thousand) from tenk1;
+ select percentile_cont(array[0,0.25,0.5,0.75,1]) within group (order by thousand) from tenk1;
+ select percentile_disc(array[[null,1,0.5],[0.75,0.25,null]]) within group (order by thousand) from tenk1;
+ select percentile_cont(array[0,1,0.25,0.75,0.5,1]) within group (order by x)
+   from generate_series(1,6) x;
+ 
+ select ten, mode() within group (order by string4) from tenk1 group by ten;
+ 
+ select percentile_disc(array[0.25,0.5,0.75]) within group (order by x)
+   from unnest('{fred,jim,fred,jack,jill,fred,jill,jim,jim,sheila,jim,sheila}'::text[]) u(x);
+ 
+ -- ordered set funcs can't use ungrouped direct args:
+ select rank(x) within group (order by x) from generate_series(1,5) x;
+ 
+ -- collation:
+ select pg_collation_for(percentile_disc(1) within group (order by x collate "POSIX"))
+   from (values ('fred'),('jim')) v(x);
+ 
+ -- hypothetical type unification and argument failures:
+ select rank(3) within group (order by x) from (values ('fred'),('jim')) v(x);
+ select rank(3) within group (order by stringu1,stringu2) from tenk1;
+ select rank('fred') within group (order by x) from generate_series(1,5) x;
+ select rank('adam'::text collate "C") within group (order by x collate "POSIX")
+   from (values ('fred'),('jim')) v(x);
+ -- hypothetical type unification successes:
+ select rank('adam'::varchar) within group (order by x) from (values ('fred'),('jim')) v(x);
+ select rank('3') within group (order by x) from generate_series(1,5) x;
+ 
+ -- deparse and multiple features:
+ create view aggordview1 as
+ select ten,
+        percentile_disc(0.5) within group (order by thousand) as p50,
+        percentile_disc(0.5) within group (order by thousand) filter (where hundred=1) as px,
+        rank(5,'AZZZZ',50) within group (order by hundred, string4 desc, hundred)
+   from tenk1
+  group by ten order by ten;
+ 
+ select pg_get_viewdef('aggordview1');
+ select * from aggordview1 order by ten;
+ drop view aggordview1;
+ 
  -- variadic aggregates
  select least_agg(q1,q2) from int8_tbl;
  select least_agg(variadic array[q1,q2]) from int8_tbl;
*** a/src/test/regress/sql/opr_sanity.sql
--- b/src/test/regress/sql/opr_sanity.sql
***************
*** 564,573 **** SELECT * FROM funcdescs
  -- **************** pg_aggregate ****************
  
  -- Look for illegal values in pg_aggregate fields.
  
  SELECT ctid, aggfnoid::oid
  FROM pg_aggregate as p1
! WHERE aggfnoid = 0 OR aggtransfn = 0 OR aggtranstype = 0;
  
  -- Make sure the matching pg_proc entry is sensible, too.
  
--- 564,581 ----
  -- **************** pg_aggregate ****************
  
  -- Look for illegal values in pg_aggregate fields.
+ -- ordered set functions can't have transfns, and must
+ -- have finalfns, but may or may not have transtypes.
+ -- other aggs must have transfns and transtypes with
+ -- optional finalfns.
  
  SELECT ctid, aggfnoid::oid
  FROM pg_aggregate as p1
! WHERE aggfnoid = 0
!    OR CASE WHEN aggisordsetfunc
!            THEN aggtransfn <> 0 OR aggfinalfn = 0
!            ELSE aggtransfn = 0 OR aggtranstype = 0
!       END;
  
  -- Make sure the matching pg_proc entry is sensible, too.
  
***************
*** 618,625 **** WHERE a.aggfnoid = p.oid AND
      a.aggfinalfn = pfn.oid AND
      (pfn.proretset
       OR NOT binary_coercible(pfn.prorettype, p.prorettype)
!      OR pfn.pronargs != 1
!      OR NOT binary_coercible(a.aggtranstype, pfn.proargtypes[0]));
  
  -- If transfn is strict then either initval should be non-NULL, or
  -- input type should match transtype so that the first non-null input
--- 626,634 ----
      a.aggfinalfn = pfn.oid AND
      (pfn.proretset
       OR NOT binary_coercible(pfn.prorettype, p.prorettype)
!      OR (aggisordsetfunc IS FALSE
!          AND (pfn.pronargs != 1
!               OR NOT binary_coercible(a.aggtranstype, pfn.proargtypes[0]))));
  
  -- If transfn is strict then either initval should be non-NULL, or
  -- input type should match transtype so that the first non-null input
***************
*** 685,695 **** WHERE p1.oid < p2.oid AND p1.proname = p2.proname AND
      array_dims(p1.proargtypes) != array_dims(p2.proargtypes)
  ORDER BY 1;
  
! -- For the same reason, we avoid creating built-in variadic aggregates.
  
! SELECT oid, proname
! FROM pg_proc AS p
! WHERE proisagg AND provariadic != 0;
  
  -- For the same reason, built-in aggregates with default arguments are no good.
  
--- 694,706 ----
      array_dims(p1.proargtypes) != array_dims(p2.proargtypes)
  ORDER BY 1;
  
! -- For the same reason, we avoid creating built-in variadic aggregates, except
! -- ordered set functions (which have their own syntax and are not subject to
! -- the misplaced ORDER BY issue).
  
! SELECT p.oid, proname
! FROM pg_proc AS p JOIN pg_aggregate AS a ON (a.aggfnoid=p.oid)
! WHERE proisagg AND provariadic != 0 AND NOT a.aggisordsetfunc;
  
  -- For the same reason, built-in aggregates with default arguments are no good.
  
